#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

from PyQt5.QtWidgets import  QWidget, QLineEdit
from PyQt5.QtCore import pyqtSignal, Qt
from PyQt5.QtGui import QTextCursor
from PyQt5 import QtGui

class ChatLineEdit(QLineEdit):
    return_signal = pyqtSignal()
    
    def __init__(self, parent: QWidget = None):
        super(ChatLineEdit, self).__init__()

    def keyPressEvent(self, e: QtGui.QKeyEvent) -> None:
        if e.key() == Qt.Key_Return or e.key() == Qt.Key_Enter:
            print("Qt.Key_Enter")
            self.return_signal.emit()
        else:
            super().keyPressEvent(e)


