#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import random
from http import HTTPStatus
import json
from dashscope import Generation  # 建议dashscope SDK 的版本 >= 1.14.0
import dashscope
from Config import Config

dashscope.api_key = Config.get_tongyi_api_key()

class ChatTalk:
    def __init__(self):
        super().__init__()

    @staticmethod
    def call_with_messages(topic: str):
        messages = [{'role': 'system', 'content': 'You are a helpful assistant.'},
                     {'role': 'user', 'content': topic}]
        response = None
        try:
            response = Generation.call(model="qwen-turbo",
                                   messages=messages,
                                   # 设置随机数种子seed，如果没有设置，则随机数种子默认为1234
                                   seed=random.randint(1, 10000),
                                   # 将输出设置为"message"格式
                                   result_format='message')
        except Exception as e:
            print(f"chat call 异常: {e}")
            return "request exception."

        if response.status_code == HTTPStatus.OK:
            print(response)
            # result = data['output']['choices'][0]['message']['content']
            result = response.output.choices[0].message.content
            print(result)
            return result
        else:
            print('Request id: %s, Status code: %s, error code: %s, error message: %s' % (
                response.request_id, response.status_code,
                response.code, response.message
            ))
            response.message = "云端AI模型接口连接失败，请检查设置信息后重试。"

            return response.message
