#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import sys
from PyQt5.QtCore import QThread, pyqtSignal
from ChatTalk import ChatTalk
from Config import Config
from XfChatTalk import XfChatTalk
from DsChatTalk import DsChatTalk
from DsChatTalkLocal import DsChatTalkLocal

class ChatTask(QThread):
    complete_signal = pyqtSignal(str)

    def __init__(self):
        super(ChatTask, self).__init__()
        self.topic = ""

    def set_topic(self, topic):
        self.topic = topic

    def run(self):
        model = Config.get_chat_model_name()
        if model == "XINGHUO":
            result = XfChatTalk.call_with_messages(self.topic)
            self.complete_signal.emit(result)
        elif model == "TONGYI":
            result = ChatTalk.call_with_messages(self.topic)
            self.complete_signal.emit(result)
        elif model == "DEEPSEEK":
            result = DsChatTalk.call_with_messages(self.topic)
            self.complete_signal.emit(result)
        elif model == "DEEPSEEKLOCAL":
            result = DsChatTalkLocal.call_with_messages(self.topic)
            self.complete_signal.emit(result)
        else:
            print("model undefine")




