# -*- coding: utf-8 -*-
#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

from Config import Config
from openai import OpenAI

api_key = Config.get_ds_api_key()


class DsChatTalk:
    def __init__(self):
        super().__init__()

    @staticmethod
    def call_with_stream(topic: str, callback):
        print("call_with_stream")
        client = OpenAI(api_key=api_key,
                        base_url="https://api.deepseek.com")
        messages = [{"role": "user", "content": topic}]
        try:
            response = client.chat.completions.create(
                model="deepseek-reasoner",
                messages=messages,
                stream=True
            )

            reasoning_content = ""
            content = ""
            first_flag = True
            start_think = True
            start_content = True

            for chunk in response:
                print(chunk)
                if chunk.choices[0].delta.reasoning_content:
                    if start_think:
                        callback("<think> \n", first_flag)
                        first_flag = False
                        start_think = False
                    reasoning_content += chunk.choices[0].delta.reasoning_content
                    callback(chunk.choices[0].delta.reasoning_content, first_flag)
                    first_flag = False

                elif chunk.choices[0].delta.content:
                    if start_content:
                        callback("</think> \n", first_flag)
                        start_content = False
                    content += chunk.choices[0].delta.content
                    callback(chunk.choices[0].delta.content, first_flag)
                    first_flag = False
                print(reasoning_content)
                print(content)

            print(reasoning_content)
            print(content)
        except Exception as e:
            print(f"client.chat.completions.create 异常: {e}")
            return "服务异常:{e}"
        print(content)
        return content

    @staticmethod
    def call_with_messages(topic: str):
        client = OpenAI(api_key=api_key,
                        base_url="https://api.deepseek.com")
        try:
            # Round 1
            messages = [{"role": "user", "content": topic}]

            response = client.chat.completions.create(
                model="deepseek-reasoner",
                messages=messages                
            )
        except Exception as e:
            print(f"client.chat.completions.create 异常: {e}")
            return "服务异常:{e}"
        print(response.choices[0].message)
        return response.choices[0].message.content







