#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

from Config import Config
import requests
import json


class DsChatTalkLocal:
    def __init__(self):
        super().__init__()

    @staticmethod
    def call_with_stream(topic: str, callback):
        print("call_with_stream")
        # 定义请求的URL、头部信息和请求体
        url = 'http://127.0.0.1:11434/api/generate'
        if Config.get_ds_local_model_url():
            url = 'http://'+ Config.get_ds_local_model_url() + '/api/generate'
        headers = {
            'Content-Type': 'application/json'
        }
        data = {
            'model': Config.get_ds_local_model(),
            'prompt': topic,
            'max_tokens': 50,
            'temperature': 0.7
        }

        content = ""
        first_flag = True

        # 发送POST请求，并设置stream=True以获取流式响应
        with requests.post(url, headers=headers, data=json.dumps(data), stream=True) as response:
            # 检查请求是否成功
            if response.status_code == 200:
                # 遍历响应的内容块
                for chunk in response.iter_content(chunk_size=8192):
                    # 处理每个数据块（这里简单地打印出来）
                    print(chunk)
                    if chunk:
                        try:
                            # 尝试解码JSON（如果服务器返回的是JSON格式的块）
                            json_obj = json.loads(chunk.decode('utf-8'))
                            # print( json_obj['response'])
                            if not json_obj['done']:
                                content += json_obj['response']
                                callback(json_obj['response'], first_flag)
                                first_flag = False
                            # json_data = json.dumps(json_obj, indent=4, ensure_ascii=False)
                            # print(json_data)

                        except json.JSONDecodeError:
                            # 如果解码失败，可能是因为块不是有效的JSON
                            # 在这种情况下，你可以根据需要进行处理（比如打印原始数据）
                            print(f"无法解码的块: {chunk.decode('utf-8')}")
                    # 注意：如果服务器没有关闭连接，这个循环会一直进行下去

                # 你可能需要实现一个机制来在适当的时候中断循环（比如超时或特定条件）

            else:
                print(f"请求失败，状态码：{response.status_code}")

        return content

    @staticmethod
    def call_with_messages(topic: str):
        # 定义请求的URL、头部信息和请求体
        url = 'http://127.0.0.1:11434/api/generate'
        headers = {
            'Content-Type': 'application/json'
        }
        data = {
            'model': Config.get_ds_local_model(),
            'prompt': topic,
            'max_tokens': 50,
            'temperature': 0.7
        }

        content = ""

        # 发送POST请求，并设置stream=True以获取流式响应
        with requests.post(url, headers=headers, data=json.dumps(data), stream=True) as response:
            # 检查请求是否成功
            if response.status_code == 200:
                # 遍历响应的内容块
                for chunk in response.iter_content(chunk_size=8192):
                    # 处理每个数据块（这里简单地打印出来）
                    if chunk:
                        try:
                            # 尝试解码JSON（如果服务器返回的是JSON格式的块）
                            json_obj = json.loads(chunk.decode('utf-8'))
                            # print( json_obj['response'])
                            if not json_obj['done']:
                                content += json_obj['response']
                            # json_data = json.dumps(json_obj, indent=4, ensure_ascii=False)
                            # print(json_data)

                        except json.JSONDecodeError:
                            # 如果解码失败，可能是因为块不是有效的JSON
                            # 在这种情况下，你可以根据需要进行处理（比如打印原始数据）
                            print(f"无法解码的块: {chunk.decode('utf-8')}")
                    # 注意：如果服务器没有关闭连接，这个循环会一直进行下去

                # 你可能需要实现一个机制来在适当的时候中断循环（比如超时或特定条件）

            else:
                print(f"请求失败，状态码：{response.status_code}")

        return content
















        client = OpenAI(api_key=api_key,
                        base_url="https://api.deepseek.com")
        try:
            # Round 1
            messages = [{"role": "system", "content": "You are a helpful assistant."},
                        {"role": "user", "content": topic}]

            response = client.chat.completions.create(
                model="deepseek-chat",
                messages=messages,
                stream=False
            )

        except Exception as e:
            print(f"client.chat.completions.create 异常: {e}")
            return "服务异常: {e}"
        print(response.choices[0].message)
        return response.choices[0].message.content







