#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import subprocess


class GetInstallStatus:
    @staticmethod
    def is_package_installed(package_name):
        try:
            # 使用 subprocess.run 执行命令
            result = subprocess.run(
                f"dpkg -l {package_name} | grep {package_name} | awk '{{ print $1 }}'",  # 命令字符串
                shell=True,  # 使用 shell 执行命令
                stdout=subprocess.PIPE,  # 捕获标准输出
                stderr=subprocess.PIPE,  # 捕获标准错误
                text=True  # 返回字符串而不是字节
            )

            # 如果命令成功执行且输出中包含软件包名称
            if result.returncode == 0 and 'ii' in result.stdout:
                return True
            else:
                return False

        except Exception as e:
            print(f"Error: {e}")
            return False


# 示例：查询 curl 是否已安装
package_name = 'curl'
if GetInstallStatus.is_package_installed(package_name):
    print(f"{package_name} is installed.")
else:
    print(f"{package_name} is not installed.")
