#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import json
import requests
from Config import Config

# NOTE: ollama must be running for this to work, start the ollama app or run `ollama serve`
model = Config.get_local_model()

class LocalTalk:

    @staticmethod
    def request_with_prompt(prompt, context):
        r = requests.post('http://127.0.0.1:11434/api/generate',
                          json={
                              'model': model,
                              'prompt': prompt,
                              'context': context,
                          },
                          stream=True)
        r.raise_for_status()

        result = ""

        for line in r.iter_lines():
            # print(line)
            body = json.loads(line)
            response_part = body.get('response', '')
            # the response streams one token at a time, print that as we receive it
            print(response_part, end='', flush=True)
            result += response_part

            # if 'error' in body:
            #     raise Exception(body['error'])
            #
            # if body.get('done', False):
            #     return body['context']
        return result
