#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import sys
from PyQt5.QtWidgets import QApplication, QMainWindow, QPushButton, QLabel, QVBoxLayout, QWidget, QMenu, QAction, \
    QActionGroup, QStyleOptionMenuItem, QStyle
from PyQt5.QtGui import QPainter, QPainterPath, QBrush, QColor
from PyQt5.QtCore import Qt, QRect, QPoint, QSize, QRectF
from PyQt5.QtWidgets import QGraphicsDropShadowEffect


class RoundedMenu(QMenu):
    def __init__(self, parent=None):
        super().__init__(parent)
        self.setWindowFlags(Qt.Popup | Qt.FramelessWindowHint)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.setStyleSheet("""
            QMenu{
                color:black; 
                background-color:rgb(255,255,255);
                border: 1px solid rgba(125,125,125,0);
                border-radius: 6px;
                padding:4px;
            }

            QMenu::item {
                background-color: transparent;
                color: black;
                border-radius: 5px;
                min-width: 90px;
                min-height:30px;
            }

            QMenu::item::selected{
                background-color: #0069F7;
            }

            QMenu::indicator:checked {
                image: url("./data/point.png");
            }
        """)

        shadow = QGraphicsDropShadowEffect(self)
        shadow.setOffset(0, 0)
        shadow.setColor(QColor(0, 0, 0, 120))
        shadow.setBlurRadius(30)
        self.setGraphicsEffect(shadow)



