#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

import sys
from PyQt5.QtCore import QThread, pyqtSignal
from Speech import Speech
from bubble_message import BubbleMessage

class SPeechTask(QThread):
    complete_signal = pyqtSignal(str)
    message = ""
    speech = None
    callback = None
    bubble_message = None

    def __init__(self):
        super(SPeechTask, self).__init__()
        self.topic = ""
        self.speech = Speech()

    def speech_callback_handle(self):
        print("callback_handle")
        if self.bubble_message:
            self.callback(self.bubble_message)

    def set_message(self, message, bubble_message=None):
        self.message = message
        self.bubble_message = bubble_message

    def set_callback(self, callback):
        self.callback = callback

    def stop_speech(self):
        print("stop_speech")
        self.speech.stop_play()

    def run(self):
        try:
            self.speech.set_callback(self.speech_callback_handle)
            self.speech.text_play(self.message)
        except Exception as e:
            print(f"合成音频输出任务异常: {e}")




