#
# Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
#
# You should have find a copy of NFSChina License. If not, please contact us
# by email <os_support@nfschina.com>
#

from openai import OpenAI
from Config import Config

api_password = Config.get_xf_api_password()

class XfChatTalk:
    def __init__(self):
        super().__init__()

    @staticmethod
    def call_with_messages(topic: str):
        client = OpenAI(
            # 控制台获取key和secret拼接，假使控制台获取的APIPassword是123456
            api_key=api_password,
            base_url='https://spark-api-open.xf-yun.com/v1'  # 指向讯飞星火的请求地址
        )
        try:
            completion = client.chat.completions.create(
                model='generalv3.5',  # 指定请求的版本
                messages=[
                    {
                        "role": "user",
                        "content": topic
                    }
                ]
            )
        except Exception as e:
            print(f"client.chat.completions.create 异常: {e}")
            return "服务异常: {e}"
        print(completion.choices[0].message)
        return completion.choices[0].message.content
